/*============================================================================
//	apci31aw.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
#include <windows.h>
#include <tchar.h>
#include "apci31aw.h"	/* aPCI-P31A */

/*-------------------------------------
// (STATIC)ϐȂ
//-----------------------------------*/
static BOOL Apci31awGetDllExportFunc();
static HMODULE hDLL = NULL;

/* DLL ߰Ċ֐ڽ̊i[ϐ */
static FARPROC pApci31aGetVersion = NULL;
static FARPROC pApci31aCreate = NULL;
static FARPROC pApci31aClose = NULL;
static FARPROC pApci31aGetResource = NULL;
static FARPROC pApci31aInPort = NULL;
static FARPROC pApci31aOutPort = NULL;
static FARPROC pApci31aGetLastError = NULL;
static FARPROC pApci31aGetSwitchValue = NULL;

/*============================================================================
// 	  apci31a.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31awDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(APCI31A_DLL_NAME);
		if (hDLL != NULL){
			Result = Apci31awGetDllExportFunc();
			if (TRUE != Result)
				Apci31awDllClose();	/* DLL֐擾ɎŝDLL۰ */
		}
	}
	return Result;
}
/*============================================================================
// 	  apci31a.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31awDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
/*============================================================================
// 	  aPCI-P31A DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31awGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31aGetVersion)(pdwDllVersion, pdwDriverVersion);
	return Result;
}
/*============================================================================
// 	  aPCI-P31A̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31awCreate(PWORD pwLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31aCreate)(pwLogSlot);
	return Result;
}
/*============================================================================
// 	  aPCI-P31A̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31awClose(WORD wLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31aClose)(wLogSlot);
	return Result;
}
/*============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31awGetResource(WORD wLogSlot, PAPCI31AR pResInfo)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31aGetResource)(wLogSlot, pResInfo);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăް
// 	  wLogSlot	͂޲̘_ۯĔԍ
//		  dwLogPort	͂_߰
//		  pbInValue ްi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31awInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31aInPort)(wLogSlot, dwLogPort, pbInValue);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăްo
// 	  wLogSlot	o͂޲̘_ۯĔԍ
//		  dwLogPort	o͂_߰
//		  bOutValue o͂ް
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31awOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31aOutPort)(wLogSlot, dwLogPort, bOutValue);
	return Result;
}
/*============================================================================
// 	  aPCI-P31A̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//==========================================================================*/
DWORD Apci31awGetLastError(WORD wLogSlot)
{
	if (NULL == hDLL)
		return APCI31A_ERR_WRAPDLL;
	else
		return (*pApci31aGetLastError)(wLogSlot);
}
/*============================================================================
// 	  ۰ذ̒l擾
//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
// 		  pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci31awGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci31aGetSwitchValue)(wLogSlot, pdwSwitchValue);
	return Result;
}
/*----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Apci31awGetDllExportFunc()
{
	/* Apci31aGetVersion ̱ڽ擾 */
	pApci31aGetVersion = GetProcAddress(hDLL, "Apci31aGetVersion");
	if (pApci31aGetVersion == NULL)
		return FALSE;

	/* Apci31aCreate ̱ڽ擾 */
	pApci31aCreate = GetProcAddress(hDLL, "Apci31aCreate");
	if (pApci31aCreate == NULL)
		return FALSE;

	/* Apci31aClose ̱ڽ擾 */
	pApci31aClose = GetProcAddress(hDLL, "Apci31aClose");
	if (pApci31aClose == NULL)
		return FALSE;

	/* Apci31aGetResource ̱ڽ擾 */
	pApci31aGetResource = GetProcAddress(hDLL, "Apci31aGetResource");
	if (pApci31aGetResource == NULL)
		return FALSE;

	/* Apci31aInPort ̱ڽ擾 */
	pApci31aInPort = GetProcAddress(hDLL, "Apci31aInPort");
	if (pApci31aInPort == NULL)
		return FALSE;

	/* Apci31aOutPort ̱ڽ擾 */
	pApci31aOutPort = GetProcAddress(hDLL, "Apci31aOutPort");
	if (pApci31aOutPort == NULL)
		return FALSE;

	/* Apci31aGetLastError ̱ڽ擾 */
	pApci31aGetLastError = GetProcAddress(hDLL, "Apci31aGetLastError");
	if (pApci31aGetLastError == NULL)
		return FALSE;

	/* Apci31aGetSwitchValue ̱ڽ擾 */
	pApci31aGetSwitchValue = GetProcAddress(hDLL, "Apci31aGetSwitchValue");
	if (pApci31aGetSwitchValue == NULL)
		return FALSE;

	return TRUE;	/* SĂ DLL ߰Ċ֐ڽ擾 */
}
